// --- [ rs232_int.h ] ---------------------------------------------------------

#ifndef RS232_INT_
#define RS232_INT_

#define BAUD  	9600
#define TEILER ((F_CPU /(BAUD * 16l)) -1)

#define TX_BUFFER_SIZE			128
#define TX_BUFFER_MASK 			(TX_BUFFER_SIZE - 1)

#define INTERRUPT		1
#define POLLING		2
#define RS232_MODE   POLLING

// Register USCR0B konfigurieren
#define TX_INT_ENABLE 	(0<<RXCIE0 | 1<<TXCIE0 | 0<<UDRIE0 | 0<<RXEN0 | 1<<TXEN0)
#define TX_INT_DISABLE	(0<<RXCIE0 | 0<<TXCIE0 | 0<<UDRIE0 | 0<<RXEN0 | 1<<TXEN0)

void rs232_init(void);
void put_c(uint8_t Zeichen);
void put_s(char *s);
void puts_p(const char *progmem_s);
void print_hexbyte(unsigned char i);

#endif
// --- [ eof ] ----------------------------------------------------------------