// --- [ spi_hard.c ] ---------------------------------------------------------

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <inttypes.h>
#include <stdlib.h> 
#include "global.h"

#if ADXL_CONNECTION == SPI
#if SPI_MODE == HARDWARE

#define SPI_DDR	DDRB
#define SPI_PORT 	PORTB
#define SPI_SCK	PB5
#define SPI_MISO	PB4				
#define SPI_MOSI	PB3
#define SPI_SS		PB2

// ----------------------------------------------------------------------------
void SPI_master_init(void)
{
													// DDR fr SlaveSelect setzen
//SPI_DDR  |= (1<<SPI_SS);					// Pin SS auf Ausgang setzen
SPI_DDR  |= (1<<SPI_SS | 1<< SPI_MOSI| 1<< SPI_SCK );
SPI_PORT |= (1<<SPI_SS);					// Pin SS auf high 
SPCR = (0<<SPIE | 1<<SPE | 0<<DORD | 1<<MSTR | 1<<CPOL | 1<<CPHA | 0<<SPR1 | 1<<SPR0);	// CLK / 16 -> 250 KHz
//SPISR |= (1<<SPI2X);

/*
// --- SPI --------------------------------------------------------------------

SPCR = (0<<SPIE | 1<<SPE | 0<<DORD | 1<<MSTR | 0<<SPI2X | 0<<SPR1 | 1<<SPR0);		// CLK 
SPI_DDR  |= (1<<SPI_SS | 1<< SPI_MOSI| 1<< SPI_SCK );
SPI_PORT |= (1<<SPI_SS);						// Slave Select auf high
*/

}

// ----------------------------------------------------------------------------
// die Pins der SPI-Schnittstelle so konfigurieren, dass kein Strom zum ADXL
// flieen kann:
// die Ausgnge als Eingnge schalten und auf LOW legen.
// den Eingang SPI_MISO auf HIGH ziehen
// Diese Manahme reduziert die Ruhestromaufnahme deutlich.
void SPI_master_clear_pins(void)
{
SPI_DDR  &= ~(1<<SPI_SS | 1<< SPI_MOSI| 1<< SPI_SCK );
SPI_PORT &= ~(1<<SPI_SS | 1<< SPI_MOSI| 1<< SPI_SCK );
SPI_PORT |=  (1<<SPI_MISO);
}
/*
// ----------------------------------------------------------------------------
uint8_t spi_write_byte(uint8_t b)
{
SPDR = b;
while (!(SPSR & (1<<SPIF)));					// warten bis SPIF gesetzt ist
return(SPDR);
}
*/

// ----------------------------------------------------------------------------
// Schreibt n-Bytes aus dem Array buff[] ber SPI raus und 
// schreibt die Antwort in das gleiche Array
void ADXL_SPI_write_array(uint8_t* buff, uint8_t i)
{

SPI_PORT &= (~(1<<SPI_SS));					// SlaveSelect auf low

while (i--)
	{
	SPDR = *buff;
	while (!(SPSR & (1<<SPIF)));				// warten bis SPIF gesetzt ist
	*buff++ = SPDR;								// empfangenes Byte speichern
	}

SPI_PORT |= (1<<SPI_SS);						// select zurcknehmen
}	



/*

do	{
	SPI_PORT &= (~(1<<SPI_SS));				// slave select auf low
	SPDR = buffer[i++];							// Buffer nach SPDR
	
	while(!(SPSR & (1<<SPIF)));				// warten bis bertragung beendet
	SPSR &= (~(1<<SPIF));	
	SPI_PORT |= (1<<SPI_SS);					// slave select auf high
	_delay_us(SPI_WAIT_US);						// Wartezeit zwischen zwei Bytes
	}
	while (buffer[i]);							// bis die nachfolgende 0 kommt

spi_ack = SPDR;									// die Rckmeldung des slave
*/
#endif
#endif

// --- [ eof ] ----------------------------------------------------------------